#ifndef __WLANINFO_H_
#define __WLANINFO_H_

// system includes
#include <asm/types.h>

//local includes
#include "p80211.h"
#include "llist.h"

#define AP_TABLE_SIZE 64
#define CL_TABLE_SIZE 128

typedef struct _my_beacon_info_t {
	__u8	mac[WLAN_ADDR_LEN];
	__u16	beacon_interval;
	__u8	channel;
	__u8	ssid[WLAN_SSID_MAXLEN];
	__u8	wep_status;
}my_beacon_info_t;

#define CLI_ST_PROBING	0
#define	CLI_ST_ASSOING	1
#define	CLI_ST_REASING	2
#define	CLI_ST_XMITING	3

typedef struct _my_client_info_t {
	__u8	mac[WLAN_ADDR_LEN];
	__u8	state;
	__u8	dest_mac[WLAN_ADDR_LEN];
}my_client_info_t;

typedef struct {
	gen_llist ll;
	my_beacon_info_t mbi;
}ap_list;

typedef struct {
	gen_llist ll;
	my_client_info_t mci;
}cl_list;

int update_ap_list(my_beacon_info_t *p_mbi);
int update_client_list(my_client_info_t *p_mci);
extern void display_wlan_stats();

#endif /* __WLANINFO_H_ */

