#ifndef __ZULU_H_
#define __ZULU_H_

/*
This program is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published by the
Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//system includes
#include <asm/types.h>

//local includes
#include "p80211.h"

#define MAX_PACK_LEN 2346
#define CONSERVATIVE_PACK_LEN 256

//the numbers such as beacon interval etc in the packet are
//not in network byte order, but in little endian format. So we dont use htons
//to convert the number here.
#define PACK_ADD(p,n)   memcpy(p,&n,sizeof(n)); \
			p += sizeof(n);

#define         WLAN_BROADCAST_ADDR     "\xff\xff\xff\xff\xff\xff"
#define         WLAN_DEFAULT_SSID       "Zulu"
#define         WLAN_DEFAULT_CHANNEL    "\x01"
#define         WLAN_DEFAULT_TIM        "\x01\x02\x00\x00"
#define         WLAN_DEFAULT_TIM_LEN    4
#define         WLAN_DEFAULT_SUPPR      "\x82\x84\x8b\x96"
#define         WLAN_DEFAULT_SUPPR_LEN  4
#define         WLAN_DEFAULT_CAPA_BEAC  0x0021
#define         WLAN_TIMESTAMP_LEN      8

#define		WLAN_DEFAULT_CAPA_ASS	0x0001
#define		WLAN_DEFAULT_LISTEN_INT 0x0001

#define		WLAN_DEFAULT_AUTH_ALGO	0x0000
#define		WLAN_DEFAULT_AUTH_SEQ	0x0001


#define         WLAN_TODS               0x10
#define         WLAN_FROMDS             0x20
#define         WLAN_FRAGMENT           0x40
#define         WLAN_RETRY              0x80
#define         WLAN_POWER              0x01
#define         WLAN_MOREDATA           0x02
#define         WLAN_WEP                0x04
#define         WLAN_ORDER              0x08

int forge_beacon(int fd_sock, unsigned char *src_mac, char *ssid, unsigned int beac_int,unsigned char channel, int count, unsigned short duration, __u8 flags, __u8 fragment, __u16 sequence);

int forge_disassoc(int fd_sock, unsigned char *src_mac, unsigned char *dest_mac, short int reason_code, int count, unsigned short duration, __u8 flags, __u16 sequence, __u8 fragment);

int forge_pspoll(int fd_sock, unsigned int count, unsigned char *src_mac, unsigned char *dest_mac, __u16 assoc_id, __u8 flags);

int forge_atim(int fd_sock, unsigned int count, unsigned char *src_mac, unsigned char *dest_mac, __u16 duration, __u8 flags, __u8 fragment, __u16 sequence);

int bw_hog(int fd_sock, unsigned char *src_mac,unsigned int pack_size, int count);

int wlan_spy(int fd_sock);

int forge_ap_flood_associate(int fd_sock, unsigned char *src_mac, unsigned char *dest_mac, char *ssid, int count, unsigned short duration, __u8 flags, __u8 fragment, __u16 sequence);

int forge_control_rts(int fd_sock, unsigned char *sender_mac, unsigned char *recv_mac, int count, unsigned short duration, __u8 flags);

int forge_control_cts(int fd_sock, unsigned char *recv_mac, int count, unsigned short duration, __u8 flags);

int forge_Data(int fd_sock, unsigned char *src_mac, unsigned char *dest_mac,int ToDS, int count, unsigned char flags, unsigned short duration, __u8 fragment, __u16 sequence, __u8 data_type);

/* Hack to represent Data NULL frames */
int forge_Data_NULL(int fd_sock, unsigned char *src_mac, unsigned char *dest_mac,int ToDS, int count, unsigned char flags, unsigned short duration);

int forge_ProbeRequest(int fd_sock, unsigned char *src_mac, char *ssid, int count, int arbitIE, unsigned short duration, __u8 flags, __u8 fragment, __u16 sequence);

int forge_Authentication(int fd_sock, unsigned char *src_mac, unsigned char *dest_mac, int auth_type, int count, unsigned short duration, __u8 flags, __u8 fragment, __u16 sequence);

int forge_associate_resp(int fd_sock, unsigned char *src_mac, unsigned char *dest_mac, int count, unsigned short duration, __u8 flags, __u8 fragment, __u16 sequence);


#endif
